diff -Naur openssl-1.0.0q.orig/crypto/bio/bio.h openssl-1.0.0q/crypto/bio/bio.h
--- openssl-1.0.0q.orig/crypto/bio/bio.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bio.h	2017-04-25 16:23:40.047526987 +0200
@@ -62,9 +62,13 @@
 #include <openssl/e_os2.h>
 
 #ifndef OPENSSL_NO_FP_API
+#ifndef OPERA_SMALL_VERSION
 # include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
+#ifndef OPERA_SMALL_VERSION
 #include <stdarg.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/crypto.h>
 
@@ -282,9 +286,26 @@
         long (*callback_ctrl)(BIO *, int, bio_info_cb *);
 	} BIO_METHOD;
 
+#define BIO_METHOD_CONST_ITEM(m_name, typ, nam, bw,br,bp,bg,ct,cr,dstr,callb) \
+	OPENSSL_PREFIX_CONST_ITEM(static, BIO_METHOD, m_name, libopeay)\
+	CONST_ITEM_ENTRY_START(type,typ)\
+	CONST_ITEM_ENTRY_SINGLE(name,NULL)\
+	CONST_ITEM_ENTRY_SINGLE(bwrite,bw)\
+	CONST_ITEM_ENTRY_SINGLE(bread,br)\
+	CONST_ITEM_ENTRY_SINGLE(bputs,bp)\
+	CONST_ITEM_ENTRY_SINGLE(bgets,bg)\
+	CONST_ITEM_ENTRY_SINGLE(ctrl,ct)\
+	CONST_ITEM_ENTRY_SINGLE(create,cr)\
+	CONST_ITEM_ENTRY_SINGLE(destroy,dstr)\
+	CONST_ITEM_ENTRY_SINGLE(callback_ctrl,callb)\
+	CONST_ITEM_ENTRY_END
+
+#define DECLARE_BIO_METHOD_ITEM(name) \
+	DECLARE_MODULE_CONST_ITEM(BIO_METHOD, name)
+
 struct bio_st
 	{
-	BIO_METHOD *method;
+	const BIO_METHOD *method;
 	/* bio, mode, argp, argi, argl, ret */
 	long (*callback)(struct bio_st *,int,const char *,int, long,long);
 	char *cb_arg; /* first argument for the callback */
@@ -578,13 +599,13 @@
 					asn1_ps_func **psuffix_free);
 
 # ifndef OPENSSL_NO_FP_API
-BIO_METHOD *BIO_s_file(void );
+const BIO_METHOD *BIO_s_file(void );
 BIO *BIO_new_file(const char *filename, const char *mode);
 BIO *BIO_new_fp(FILE *stream, int close_flag);
 # define BIO_s_file_internal	BIO_s_file
 # endif
-BIO *	BIO_new(BIO_METHOD *type);
-int	BIO_set(BIO *a,BIO_METHOD *type);
+BIO *	BIO_new(const BIO_METHOD *type);
+int	BIO_set(BIO *a,const BIO_METHOD *type);
 int	BIO_free(BIO *a);
 void	BIO_vfree(BIO *a);
 int	BIO_read(BIO *b, void *data, int len);
@@ -613,7 +634,7 @@
 long BIO_debug_callback(BIO *bio,int cmd,const char *argp,int argi,
 	long argl,long ret);
 
-BIO_METHOD *BIO_s_mem(void);
+const BIO_METHOD *BIO_s_mem(void);
 BIO *BIO_new_mem_buf(void *buf, int len);
 BIO_METHOD *BIO_s_socket(void);
 BIO_METHOD *BIO_s_connect(void);
@@ -623,7 +644,7 @@
 BIO_METHOD *BIO_s_log(void);
 #endif
 BIO_METHOD *BIO_s_bio(void);
-BIO_METHOD *BIO_s_null(void);
+const BIO_METHOD *BIO_s_null(void);
 BIO_METHOD *BIO_f_null(void);
 BIO_METHOD *BIO_f_buffer(void);
 #ifdef OPENSSL_SYS_VMS
diff -Naur openssl-1.0.0q.orig/crypto/bio/bio_cb.c openssl-1.0.0q/crypto/bio/bio_cb.c
--- openssl-1.0.0q.orig/crypto/bio/bio_cb.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bio_cb.c	2017-04-25 16:23:40.047526987 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bio.h>
 #include <openssl/err.h>
diff -Naur openssl-1.0.0q.orig/crypto/bio/bio_err.c openssl-1.0.0q/crypto/bio/bio_err.c
--- openssl-1.0.0q.orig/crypto/bio/bio_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bio_err.c	2017-04-25 16:23:40.049526682 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/bio.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/bio/bio_lib.c openssl-1.0.0q/crypto/bio/bio_lib.c
--- openssl-1.0.0q.orig/crypto/bio/bio_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bio_lib.c	2017-04-25 16:23:40.050527089 +0200
@@ -56,14 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include <openssl/crypto.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 #include <openssl/stack.h>
 
-BIO *BIO_new(BIO_METHOD *method)
+BIO *BIO_new(const BIO_METHOD *method)
 	{
 	BIO *ret=NULL;
 
@@ -81,7 +82,7 @@
 	return(ret);
 	}
 
-int BIO_set(BIO *bio, BIO_METHOD *method)
+int BIO_set(BIO *bio, const BIO_METHOD *method)
 	{
 	bio->method=method;
 	bio->callback=NULL;
@@ -138,8 +139,10 @@
 	return(1);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void BIO_vfree(BIO *a)
     { BIO_free(a); }
+#endif
 
 void BIO_clear_flags(BIO *b, int flags)
 	{
@@ -200,7 +203,7 @@
 
 	cb=b->callback;
 	if ((cb != NULL) &&
-		((i=(int)cb(b,BIO_CB_READ,out,outl,0L,1L)) <= 0))
+		((i=(int)cb(b,BIO_CB_READ, (const char *) out,outl,0L,1L)) <= 0))
 			return(i);
 
 	if (!b->init)
@@ -209,12 +212,12 @@
 		return(-2);
 		}
 
-	i=b->method->bread(b,out,outl);
+	i=b->method->bread(b,(char *) out,outl);
 
 	if (i > 0) b->num_read+=(unsigned long)i;
 
 	if (cb != NULL)
-		i=(int)cb(b,BIO_CB_READ|BIO_CB_RETURN,out,outl,
+		i=(int)cb(b,BIO_CB_READ|BIO_CB_RETURN,(const char *) out,outl,
 			0L,(long)i);
 	return(i);
 	}
@@ -235,7 +238,7 @@
 		}
 
 	if ((cb != NULL) &&
-		((i=(int)cb(b,BIO_CB_WRITE,in,inl,0L,1L)) <= 0))
+		((i=(int)cb(b,BIO_CB_WRITE,(const char *) in,inl,0L,1L)) <= 0))
 			return(i);
 
 	if (!b->init)
@@ -244,12 +247,12 @@
 		return(-2);
 		}
 
-	i=b->method->bwrite(b,in,inl);
+	i=b->method->bwrite(b,(const char *) in,inl);
 
 	if (i > 0) b->num_write+=(unsigned long)i;
 
 	if (cb != NULL)
-		i=(int)cb(b,BIO_CB_WRITE|BIO_CB_RETURN,in,inl,
+		i=(int)cb(b,BIO_CB_WRITE|BIO_CB_RETURN,(const char *) in,inl,
 			0L,(long)i);
 	return(i);
 	}
@@ -364,13 +367,13 @@
 	cb=b->callback;
 
 	if ((cb != NULL) &&
-		((ret=cb(b,BIO_CB_CTRL,parg,cmd,larg,1L)) <= 0))
+		((ret=cb(b,BIO_CB_CTRL,(const char *) parg,cmd,larg,1L)) <= 0))
 		return(ret);
 
 	ret=b->method->ctrl(b,cmd,larg,parg);
 
 	if (cb != NULL)
-		ret=cb(b,BIO_CB_CTRL|BIO_CB_RETURN,parg,cmd,
+		ret=cb(b,BIO_CB_CTRL|BIO_CB_RETURN,(const char *) parg,cmd,
 			larg,ret);
 	return(ret);
 	}
@@ -391,13 +394,13 @@
 	cb=b->callback;
 
 	if ((cb != NULL) &&
-		((ret=cb(b,BIO_CB_CTRL,(void *)&fp,cmd,0,1L)) <= 0))
+		((ret=cb(b,BIO_CB_CTRL,(const char *)&fp,cmd,0,1L)) <= 0))
 		return(ret);
 
 	ret=b->method->callback_ctrl(b,cmd,fp);
 
 	if (cb != NULL)
-		ret=cb(b,BIO_CB_CTRL|BIO_CB_RETURN,(void *)&fp,cmd,
+		ret=cb(b,BIO_CB_CTRL|BIO_CB_RETURN,(const char*)&fp,cmd,
 			0,ret);
 	return(ret);
 	}
@@ -415,7 +418,6 @@
 	return BIO_ctrl(bio, BIO_CTRL_WPENDING, 0, NULL);
 	}
 
-
 /* put the 'bio' on the end of b's list of operators */
 BIO *BIO_push(BIO *b, BIO *bio)
 	{
@@ -433,6 +435,7 @@
 	return(b);
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 /* Remove the first and return the rest */
 BIO *BIO_pop(BIO *b)
 	{
@@ -473,6 +476,7 @@
 	{
 	return(bio->retry_reason);
 	}
+#endif
 
 BIO *BIO_find_type(BIO *bio, int type)
 	{
@@ -519,6 +523,7 @@
 		}
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 BIO *BIO_dup_chain(BIO *in)
 	{
 	BIO *ret=NULL,*eoc=NULL,*bio,*new_bio;
@@ -563,6 +568,7 @@
 		BIO_free(ret);
 	return(NULL);	
 	}
+#endif
 
 void BIO_copy_next_retry(BIO *b)
 	{
@@ -570,6 +576,7 @@
 	b->retry_reason=b->next_bio->retry_reason;
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int BIO_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func,
 	     CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
 	{
@@ -598,5 +605,6 @@
 	if(bio) return bio->num_write;
 	return 0;
 }
+#endif
 
 IMPLEMENT_STACK_OF(BIO)
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_acpt.c openssl-1.0.0q/crypto/bio/bss_acpt.c
--- openssl-1.0.0q.orig/crypto/bio/bss_acpt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_acpt.c	2017-04-25 16:23:40.051526378 +0200
@@ -56,10 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #define USE_SOCKETS
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 
 #ifndef OPENSSL_NO_SOCK
@@ -148,7 +150,7 @@
 	if ((ret=(BIO_ACCEPT *)OPENSSL_malloc(sizeof(BIO_ACCEPT))) == NULL)
 		return(NULL);
 
-	memset(ret,0,sizeof(BIO_ACCEPT));
+	op_memset(ret,0,sizeof(BIO_ACCEPT));
 	ret->accept_sock=INVALID_SOCKET;
 	ret->bind_mode=BIO_BIND_NORMAL;
 	return(ret);
@@ -455,7 +457,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=acpt_write(bp,str,n);
 	return(ret);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_bio.c openssl-1.0.0q/crypto/bio/bss_bio.c
--- openssl-1.0.0q.orig/crypto/bio/bss_bio.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_bio.c	2017-04-25 16:23:40.052526505 +0200
@@ -74,10 +74,12 @@
 # endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
 #include <limits.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/bio.h>
 #include <openssl/err.h>
@@ -245,7 +247,7 @@
 			chunk = peer_b->size - peer_b->offset;
 		assert(peer_b->offset + chunk <= peer_b->size);
 		
-		memcpy(buf, peer_b->buf + peer_b->offset, chunk);
+		op_memcpy(buf, peer_b->buf + peer_b->offset, chunk);
 		
 		peer_b->len -= chunk;
 		if (peer_b->len)
@@ -408,7 +410,7 @@
 			/* wrap around ring buffer */
 			chunk = b->size - write_offset;
 		
-		memcpy(b->buf + write_offset, buf, chunk);
+		op_memcpy(b->buf + write_offset, buf, chunk);
 		
 		b->len += chunk;
 
@@ -697,7 +699,7 @@
 
 static int bio_puts(BIO *bio, const char *str)
 	{
-	return bio_write(bio, str, strlen(str));
+	return bio_write(bio, str, op_strlen(str));
 	}
 
 
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_conn.c openssl-1.0.0q/crypto/bio/bss_conn.c
--- openssl-1.0.0q.orig/crypto/bio/bss_conn.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_conn.c	2017-04-25 16:23:40.053526353 +0200
@@ -56,8 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #define USE_SOCKETS
 #include "cryptlib.h"
 #include <openssl/bio.h>
@@ -198,7 +203,7 @@
 
 		case BIO_CONN_S_CREATE_SOCKET:
 			/* now setup address */
-			memset((char *)&c->them,0,sizeof(c->them));
+			op_memset((char *)&c->them,0,sizeof(c->them));
 			c->them.sin_family=AF_INET;
 			c->them.sin_port=htons((unsigned short)c->port);
 			l=(unsigned long)
@@ -334,7 +339,7 @@
 	ret->ip[2]=0;
 	ret->ip[3]=0;
 	ret->port=0;
-	memset((char *)&ret->them,0,sizeof(ret->them));
+	op_memset((char *)&ret->them,0,sizeof(ret->them));
 	return(ret);
 	}
 
@@ -526,7 +531,7 @@
 				if (data->param_hostname != NULL)
 					OPENSSL_free(data->param_hostname);
 				data->param_hostname=BUF_strdup(buf);
-				memcpy(&(data->ip[0]),ptr,4);
+				op_memcpy(&(data->ip[0]),ptr,4);
 				}
 			else if (num == 3)
 				{
@@ -628,7 +633,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=conn_write(bp,str,n);
 	return(ret);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_fd.c openssl-1.0.0q/crypto/bio/bss_fd.c
--- openssl-1.0.0q.orig/crypto/bio/bss_fd.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_fd.c	2017-04-25 16:23:40.054526200 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #define USE_SOCKETS
 #include "cryptlib.h"
 
@@ -230,7 +232,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=fd_write(bp,str,n);
 	return(ret);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_file.c openssl-1.0.0q/crypto/bio/bss_file.c
--- openssl-1.0.0q.orig/crypto/bio/bss_file.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_file.c	2017-04-25 16:23:40.055526328 +0200
@@ -62,9 +62,13 @@
  *		Windows
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #ifndef HEADER_BSS_FILE_C
 #define HEADER_BSS_FILE_C
 
+#ifndef OPERA_SMALL_VERSION
 #if defined(__linux) || defined(__sun) || defined(__hpux)
 /* Following definition aliases fopen to fopen64 on above mentioned
  * platforms. This makes it possible to open and sequentially access
@@ -85,6 +89,7 @@
 
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include "bio_lcl.h"
 #include <openssl/err.h>
@@ -102,7 +107,7 @@
 static long MS_CALLBACK file_ctrl(BIO *h, int cmd, long arg1, void *arg2);
 static int MS_CALLBACK file_new(BIO *h);
 static int MS_CALLBACK file_free(BIO *data);
-static BIO_METHOD methods_filep=
+static const BIO_METHOD methods_filep=
 	{
 	BIO_TYPE_FILE,
 	"FILE pointer",
@@ -167,7 +172,9 @@
 	if (file == NULL)
 		{
 		SYSerr(SYS_F_FOPEN,get_last_sys_error());
+#ifndef OPERA_SMALL_VERSION
 		ERR_add_error_data(5,"fopen('",filename,"','",mode,"')");
+#endif
 		if (errno == ENOENT)
 			BIOerr(BIO_F_BIO_NEW_FILE,BIO_R_NO_SUCH_FILE);
 		else
@@ -197,7 +204,7 @@
 	return(ret);
 	}
 
-BIO_METHOD *BIO_s_file(void)
+const BIO_METHOD *BIO_s_file(void)
 	{
 	return(&methods_filep);
 	}
@@ -382,9 +389,9 @@
 			}
 #if defined(OPENSSL_SYS_MSDOS) || defined(OPENSSL_SYS_WINDOWS) || defined(OPENSSL_SYS_OS2) || defined(OPENSSL_SYS_WIN32_CYGWIN)
 		if (!(num & BIO_FP_TEXT))
-			strcat(p,"b");
+			op_strcat(p,"b");
 		else
-			strcat(p,"t");
+			op_strcat(p,"t");
 #endif
 #if defined(OPENSSL_SYS_NETWARE)
 		if (!(num & BIO_FP_TEXT))
@@ -396,7 +403,9 @@
 		if (fp == NULL)
 			{
 			SYSerr(SYS_F_FOPEN,get_last_sys_error());
+#ifndef OPERA_SMALL_VERSION
 			ERR_add_error_data(5,"fopen('",ptr,"','",p,"')");
+#endif
 			BIOerr(BIO_F_FILE_CTRL,ERR_R_SYS_LIB);
 			ret=0;
 			break;
@@ -465,7 +474,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=file_write(bp,str,n);
 	return(ret);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_log.c openssl-1.0.0q/crypto/bio/bss_log.c
--- openssl-1.0.0q.orig/crypto/bio/bss_log.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_log.c	2017-04-25 16:23:40.056526175 +0200
@@ -58,13 +58,18 @@
 
 	BIO_s_log is useful for system daemons (or services under NT).
 	It is one-way BIO, it sends all stuff to syslogd (on system that
-	commonly use that), or event log (on NT), or OPCOM (on OpenVMS).
+	commonly use that), or event op_log (on NT), or OPCOM (on OpenVMS).
 
 */
 
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "cryptlib.h"
 
@@ -204,11 +209,11 @@
 	if((buf= (char *)OPENSSL_malloc(inl+ 1)) == NULL){
 		return(0);
 	}
-	strncpy(buf, in, inl);
+	op_strncpy(buf, in, inl);
 	buf[inl]= '\0';
 
 	i = 0;
-	while(strncmp(buf, mapping[i].str, mapping[i].strl) != 0) i++;
+	while(op_strncmp(buf, mapping[i].str, mapping[i].strl) != 0) i++;
 	priority = mapping[i].log_level;
 	pp = buf + mapping[i].strl;
 
@@ -236,7 +241,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=slg_write(bp,str,n);
 	return(ret);
 	}
@@ -355,9 +360,9 @@
 	/* We know there's an 8-byte header.  That's documented. */
 	opcdef_p = OPCDEF_MALLOC( 8+ len);
 	opcdef_p->opc$b_ms_type = OPC$_RQ_RQST;
-	memcpy(opcdef_p->opc$z_ms_target_classes, &VMS_OPC_target, 3);
+	op_memcpy(opcdef_p->opc$z_ms_target_classes, &VMS_OPC_target, 3);
 	opcdef_p->opc$l_ms_rqstid = 0;
-	memcpy(&opcdef_p->opc$l_ms_text, buf, len);
+	op_memcpy(&opcdef_p->opc$l_ms_text, buf, len);
 
 	opc_dsc.dsc$b_dtype = DSC$K_DTYPE_T;
 	opc_dsc.dsc$b_class = DSC$K_CLASS_S;
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_mem.c openssl-1.0.0q/crypto/bio/bss_mem.c
--- openssl-1.0.0q.orig/crypto/bio/bss_mem.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_mem.c	2017-04-25 16:23:40.057526023 +0200
@@ -56,10 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int mem_write(BIO *h, const char *buf, int num);
 static int mem_read(BIO *h, char *buf, int size);
@@ -68,8 +72,7 @@
 static long mem_ctrl(BIO *h, int cmd, long arg1, void *arg2);
 static int mem_new(BIO *h);
 static int mem_free(BIO *data);
-static BIO_METHOD mem_method=
-	{
+BIO_METHOD_CONST_ITEM(bss_mem__mem_method,
 	BIO_TYPE_MEM,
 	"memory buffer",
 	mem_write,
@@ -79,13 +82,14 @@
 	mem_ctrl,
 	mem_new,
 	mem_free,
-	NULL,
-	};
+	NULL
+	);
+#define mem_method OPENSSL_GLOBAL_ITEM_NAME(bss_mem__mem_method)
 
 /* bio->num is used to hold the value to return on 'empty', if it is
  * 0, should_retry is not set */
 
-BIO_METHOD *BIO_s_mem(void)
+const BIO_METHOD *BIO_s_mem(void)
 	{
 	return(&mem_method);
 	}
@@ -100,10 +104,10 @@
 		BIOerr(BIO_F_BIO_NEW_MEM_BUF,BIO_R_NULL_PARAMETER);
 		return NULL;
 	}
-	sz = (len<0) ? strlen(buf) : (size_t)len;
+	sz = (len<0) ? strlen((const char*)buf) : (size_t)len;
 	if(!(ret = BIO_new(BIO_s_mem())) ) return NULL;
 	b = (BUF_MEM *)ret->ptr;
-	b->data = buf;
+	b->data = (char*)buf;
 	b->length = sz;
 	b->max = sz;
 	ret->flags |= BIO_FLAGS_MEM_RDONLY;
@@ -151,7 +155,7 @@
 	BIO_clear_retry_flags(b);
 	ret=(outl >=0 && (size_t)outl > bm->length)?(int)bm->length:outl;
 	if ((out != NULL) && (ret > 0)) {
-		memcpy(out,bm->data,ret);
+		op_memcpy(out,bm->data,ret);
 		bm->length-=ret;
 		if(b->flags & BIO_FLAGS_MEM_RDONLY) bm->data += ret;
 		else {
@@ -188,7 +192,7 @@
 	blen=bm->length;
 	if (BUF_MEM_grow_clean(bm,blen+inl) != (blen+inl))
 		goto end;
-	memcpy(&(bm->data[blen]),in,inl);
+	op_memcpy(&(bm->data[blen]),in,inl);
 	ret=inl;
 end:
 	return(ret);
@@ -214,7 +218,7 @@
 				}
 			else
 				{
-				memset(bm->data,0,bm->max);
+				op_memset(bm->data,0,bm->max);
 				bm->length=0;
 				}
 			}
@@ -311,7 +315,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=mem_write(bp,str,n);
 	/* memory semantics is that it will always work */
 	return(ret);
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_null.c openssl-1.0.0q/crypto/bio/bss_null.c
--- openssl-1.0.0q.orig/crypto/bio/bss_null.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_null.c	2017-04-25 16:23:40.058526150 +0200
@@ -56,10 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int null_write(BIO *h, const char *buf, int num);
 static int null_read(BIO *h, char *buf, int size);
@@ -68,8 +73,7 @@
 static long null_ctrl(BIO *h, int cmd, long arg1, void *arg2);
 static int null_new(BIO *h);
 static int null_free(BIO *data);
-static BIO_METHOD null_method=
-	{
+BIO_METHOD_CONST_ITEM(bss_null__null_method,
 	BIO_TYPE_NULL,
 	"NULL",
 	null_write,
@@ -79,10 +83,11 @@
 	null_ctrl,
 	null_new,
 	null_free,
-	NULL,
-	};
+	NULL
+	);
+#define null_method OPENSSL_GLOBAL_ITEM_NAME(bss_null__null_method)
 
-BIO_METHOD *BIO_s_null(void)
+const BIO_METHOD *BIO_s_null(void)
 	{
 	return(&null_method);
 	}
@@ -145,6 +150,6 @@
 static int null_puts(BIO *bp, const char *str)
 	{
 	if (str == NULL) return(0);
-	return(strlen(str));
+	return(op_strlen(str));
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_rtcp.c openssl-1.0.0q/crypto/bio/bss_rtcp.c
--- openssl-1.0.0q.orig/crypto/bio/bss_rtcp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_rtcp.c	2017-04-25 16:23:40.059526557 +0200
@@ -61,10 +61,15 @@
  * Revised: 25-SEP-1997		Update for 0.8.1, BIO_CTRL_SET -> BIO_C_SET_FD
  */
 /* VMS */
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bio.h>
 
@@ -182,7 +187,7 @@
     if ( ctx->pos < ctx->filled ) {
 	length = ctx->filled - ctx->pos;
 	if ( length > outl ) length = outl;
-	memmove ( out, &ctx->msg.data[ctx->pos], length );
+	op_memmove ( out, &ctx->msg.data[ctx->pos], length );
 	ctx->pos += length;
 	return length;
     }
@@ -210,7 +215,7 @@
     if ( ctx->pos < ctx->filled ) {
 	length = ctx->filled - ctx->pos;
 	if ( length > outl ) length = outl;
-	memmove ( out, ctx->msg.data, length );
+	op_memmove ( out, ctx->msg.data, length );
 	ctx->pos += length;
 	return length;
     }
@@ -232,7 +237,7 @@
 	ctx->msg.channel = 'R';
 	ctx->msg.function = 'P';
 	ctx->msg.length = segment;
-	memmove ( ctx->msg.data, &in[i], segment );
+	op_memmove ( ctx->msg.data, &in[i], segment );
 	status = put ( b->num, (char *) &ctx->msg, segment + RPC_HDR_SIZE );
 	if ((status&1) == 0 ) { i = -1; break; }
 
@@ -287,7 +292,7 @@
 {
     int length;
     if (str == NULL) return(0);
-    length = strlen ( str );
+    length = op_strlen ( str );
     if ( length == 0 ) return (0);
     return rtcp_write ( bp,str, length );
 }
diff -Naur openssl-1.0.0q.orig/crypto/bio/bss_sock.c openssl-1.0.0q/crypto/bio/bss_sock.c
--- openssl-1.0.0q.orig/crypto/bio/bss_sock.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/bss_sock.c	2017-04-25 16:23:40.060526125 +0200
@@ -56,10 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #define USE_SOCKETS
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_SOCK
 
@@ -209,7 +211,7 @@
 	{
 	int n,ret;
 
-	n=strlen(str);
+	n=op_strlen(str);
 	ret=sock_write(bp,str,n);
 	return(ret);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/bio/opera_b_dump.cpp openssl-1.0.0q/crypto/bio/opera_b_dump.cpp
--- openssl-1.0.0q.orig/crypto/bio/opera_b_dump.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bio/opera_b_dump.cpp	2017-04-25 16:23:40.061527090 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "b_dump.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/bn/.gitignore openssl-1.0.0q/crypto/bn/.gitignore
--- openssl-1.0.0q.orig/crypto/bn/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/.gitignore	2017-04-25 16:23:40.064526075 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn.h openssl-1.0.0q/crypto/bn/bn.h
--- openssl-1.0.0q.orig/crypto/bn/bn.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn.h	2017-04-25 16:23:40.065525923 +0200
@@ -127,7 +127,9 @@
 
 #include <openssl/e_os2.h>
 #ifndef OPENSSL_NO_FP_API
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h> /* FILE */
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #include <openssl/ossl_typ.h>
 #include <openssl/crypto.h>
@@ -211,7 +213,7 @@
 #define BN_BYTES	8
 #define BN_BITS2	64
 #define BN_BITS4	32
-#define BN_MASK2	(0xffffffffffffffffLL)
+#define BN_MASK2	(0xffffffffffffffffULL)
 #define BN_MASK2l	(0xffffffffL)
 #define BN_MASK2h	(0xffffffff00000000LL)
 #define BN_MASK2h1	(0xffffffff80000000LL)
@@ -358,7 +360,7 @@
 	union
 		{
 		/* if(ver==1) - handles old style callbacks */
-		void (*cb_1)(int, int, void *);
+		int (*cb_1)(int, int, void *);
 		/* if(ver==2) - new callback style */
 		int (*cb_2)(int, int, BN_GENCB *);
 		} cb;
@@ -544,12 +546,12 @@
 #ifndef OPENSSL_NO_DEPRECATED
 BIGNUM *BN_generate_prime(BIGNUM *ret,int bits,int safe,
 	const BIGNUM *add, const BIGNUM *rem,
-	void (*callback)(int,int,void *),void *cb_arg);
+	int (*callback)(int,int,void *),void *cb_arg);
 int	BN_is_prime(const BIGNUM *p,int nchecks,
-	void (*callback)(int,int,void *),
+	int (*callback)(int,int,void *),
 	BN_CTX *ctx,void *cb_arg);
 int	BN_is_prime_fasttest(const BIGNUM *p,int nchecks,
-	void (*callback)(int,int,void *),BN_CTX *ctx,void *cb_arg,
+	int (*callback)(int,int,void *),BN_CTX *ctx,void *cb_arg,
 	int do_trial_division);
 #endif /* !defined(OPENSSL_NO_DEPRECATED) */
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_add.c openssl-1.0.0q/crypto/bn/bn_add.c
--- openssl-1.0.0q.orig/crypto/bn/bn_add.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_add.c	2017-04-25 16:23:40.066526050 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 /* r can == a or b */
@@ -234,7 +236,7 @@
 			}
 		}
 #if 0
-	memcpy(rp,ap,sizeof(*rp)*(max-i));
+	op_memcpy(rp,ap,sizeof(*rp)*(max-i));
 #else
 	if (rp != ap)
 		{
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_asm.c openssl-1.0.0q/crypto/bn/bn_asm.c
--- openssl-1.0.0q.orig/crypto/bn/bn_asm.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_asm.c	2017-04-25 16:23:40.067526177 +0200
@@ -56,14 +56,18 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef PRODUCT_COMPILES_BN_ASM
+
 #ifndef BN_DEBUG
 # undef NDEBUG /* avoid conflicting definitions */
 # define NDEBUG
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <assert.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 #if defined(BN_LLONG) || defined(BN_UMULT_HIGH)
@@ -1032,3 +1036,5 @@
 #endif
 
 #endif /* !BN_MUL_COMBA */
+
+#endif /* !PRODUCT_COMPILES_BN_ASM */
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_blind.c openssl-1.0.0q/crypto/bn/bn_blind.c
--- openssl-1.0.0q.orig/crypto/bn/bn_blind.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_blind.c	2017-04-25 16:23:40.068526863 +0200
@@ -109,8 +109,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 #define BN_BLINDING_COUNTER	32
@@ -134,6 +136,7 @@
 			  BN_MONT_CTX *m_ctx);
 	};
 
+#ifndef OPERA_SMALL_VERSION
 BN_BLINDING *BN_BLINDING_new(const BIGNUM *A, const BIGNUM *Ai, BIGNUM *mod)
 	{
 	BN_BLINDING *ret=NULL;
@@ -145,7 +148,7 @@
 		BNerr(BN_F_BN_BLINDING_NEW,ERR_R_MALLOC_FAILURE);
 		return(NULL);
 		}
-	memset(ret,0,sizeof(BN_BLINDING));
+	op_memset(ret,0,sizeof(BN_BLINDING));
 	if (A != NULL)
 		{
 		if ((ret->A  = BN_dup(A))  == NULL) goto err;
@@ -383,3 +386,4 @@
 
 	return ret;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_ctx.c openssl-1.0.0q/crypto/bn/bn_ctx.c
--- openssl-1.0.0q.orig/crypto/bn/bn_ctx.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_ctx.c	2017-04-25 16:23:40.069526152 +0200
@@ -60,10 +60,12 @@
 #endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 /* TODO list
@@ -213,7 +215,7 @@
 
 BN_CTX *BN_CTX_new(void)
 	{
-	BN_CTX *ret = OPENSSL_malloc(sizeof(BN_CTX));
+	BN_CTX *ret = (BN_CTX *) OPENSSL_malloc(sizeof(BN_CTX));
 	if(!ret)
 		{
 		BNerr(BN_F_BN_CTX_NEW,ERR_R_MALLOC_FAILURE);
@@ -334,11 +336,11 @@
 		{
 		unsigned int newsize = (st->size ?
 				(st->size * 3 / 2) : BN_CTX_START_FRAMES);
-		unsigned int *newitems = OPENSSL_malloc(newsize *
+		unsigned int *newitems = (unsigned int *) OPENSSL_malloc(newsize *
 						sizeof(unsigned int));
 		if(!newitems) return 0;
 		if(st->depth)
-			memcpy(newitems, st->indexes, st->depth *
+			op_memcpy(newitems, st->indexes, st->depth *
 						sizeof(unsigned int));
 		if(st->size) OPENSSL_free(st->indexes);
 		st->indexes = newitems;
@@ -406,7 +408,7 @@
 		{
 		BIGNUM *bn;
 		unsigned int loop = 0;
-		BN_POOL_ITEM *item = OPENSSL_malloc(sizeof(BN_POOL_ITEM));
+		BN_POOL_ITEM *item = (BN_POOL_ITEM *) OPENSSL_malloc(sizeof(BN_POOL_ITEM));
 		if(!item) return NULL;
 		/* Initialise the structure */
 		bn = item->vals;
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_div.c openssl-1.0.0q/crypto/bn/bn_div.c
--- openssl-1.0.0q.orig/crypto/bn/bn_div.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_div.c	2017-04-25 16:23:40.070526558 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/bn.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_err.c openssl-1.0.0q/crypto/bn/bn_err.c
--- openssl-1.0.0q.orig/crypto/bn/bn_err.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_err.c	2017-04-25 16:23:40.071526685 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/bn.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_exp.c openssl-1.0.0q/crypto/bn/bn_exp.c
--- openssl-1.0.0q.orig/crypto/bn/bn_exp.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_exp.c	2017-04-25 16:23:40.072527930 +0200
@@ -110,12 +110,13 @@
  */
 
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 /* maximum precomputation table size for *variable* sliding windows */
 #define TABLE_SIZE	32
 
+#ifndef OPERA_SMALL_VERSION
 /* this one works - simple but works */
 int BN_exp(BIGNUM *r, const BIGNUM *a, const BIGNUM *p, BN_CTX *ctx)
 	{
@@ -159,8 +160,9 @@
 	bn_check_top(r);
 	return(ret);
 	}
+#endif
 
-
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_PKCS12_SUPPORT || defined(NEED_LIBOPEAY_ELGAMAL)
 int BN_mod_exp(BIGNUM *r, const BIGNUM *a, const BIGNUM *p, const BIGNUM *m,
 	       BN_CTX *ctx)
 	{
@@ -367,6 +369,7 @@
 	bn_check_top(r);
 	return(ret);
 	}
+#endif // !defined OPERA_SMALL_VERSION || defined LIBOPEAY_PKCS12_SUPPORT || defined(NEED_LIBOPEAY_ELGAMAL)
 
 
 int BN_mod_exp_mont(BIGNUM *rr, const BIGNUM *a, const BIGNUM *p,
@@ -630,7 +633,7 @@
 		goto err;
 		
 	powerbuf = MOD_EXP_CTIME_ALIGN(powerbufFree);
-	memset(powerbuf, 0, powerbufLen);
+	op_memset(powerbuf, 0, powerbufLen);
 
  	/* Initialize the intermediate result. Do this early to save double conversion,
 	 * once each for a^0 and intermediate result.
@@ -879,6 +882,7 @@
 	}
 
 
+#ifndef OPERA_SMALL_VERSION
 /* The old fallback, simple version :-) */
 int BN_mod_exp_simple(BIGNUM *r, const BIGNUM *a, const BIGNUM *p,
 		const BIGNUM *m, BN_CTX *ctx)
@@ -995,4 +999,4 @@
 	bn_check_top(r);
 	return(ret);
 	}
-
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_exp2.c openssl-1.0.0q/crypto/bn/bn_exp2.c
--- openssl-1.0.0q.orig/crypto/bn/bn_exp2.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_exp2.c	2017-04-25 16:23:40.073526939 +0200
@@ -109,8 +109,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+
+#if !defined OPERA_SMALL_VERSION || !defined OPENSSL_NO_DSA
 #include "bn_lcl.h"
 
 #define TABLE_SIZE	32
@@ -310,3 +314,4 @@
 	bn_check_top(rr);
 	return(ret);
 	}
+#endif
